#include "common.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>

#ifdef __cplusplus
extern "C" {
#endif

int
LLVMFuzzerTestOneInput(const uint8_t *data, size_t size) {
    size_t i = 0;

    int8_t int8_eq_const_0_0;
    uint16_t uint16_eq_const_1_0;
    int32_t int32_eq_const_2_0;
    uint64_t uint64_eq_const_3_0;
    int16_t int16_eq_const_4_0;
    uint64_t uint64_eq_const_5_0;
    int8_t int8_eq_const_6_0;
    int64_t int64_eq_const_7_0;
    uint8_t uint8_eq_const_8_0;
    uint64_t uint64_eq_const_9_0;

    if (size < 43)
        return TEPHRA_EXIT_FAILURE;


    memcpy(&int8_eq_const_0_0, &data[i], 1);
    i += 1;
    memcpy(&uint16_eq_const_1_0, &data[i], 2);
    i += 2;
    memcpy(&int32_eq_const_2_0, &data[i], 4);
    i += 4;
    memcpy(&uint64_eq_const_3_0, &data[i], 8);
    i += 8;
    memcpy(&int16_eq_const_4_0, &data[i], 2);
    i += 2;
    memcpy(&uint64_eq_const_5_0, &data[i], 8);
    i += 8;
    memcpy(&int8_eq_const_6_0, &data[i], 1);
    i += 1;
    memcpy(&int64_eq_const_7_0, &data[i], 8);
    i += 8;
    memcpy(&uint8_eq_const_8_0, &data[i], 1);
    i += 1;
    memcpy(&uint64_eq_const_9_0, &data[i], 8);
    i += 8;


    if (int8_eq_const_0_0 == 53)
    if (uint16_eq_const_1_0 == 46232)
    if (int32_eq_const_2_0 == 82744654)
    if (uint64_eq_const_3_0 == 12812370111806915351u)
    if (int16_eq_const_4_0 == -16487)
    if (uint64_eq_const_5_0 == 3721927845148300137u)
    if (int8_eq_const_6_0 == 22)
    if (int64_eq_const_7_0 == -6962828145793899542)
    if (uint8_eq_const_8_0 == 224)
    if (uint64_eq_const_9_0 == 10056289562957667679u)
        BOOM();

    return TEPHRA_EXIT_SUCCESS;
}

#ifdef __cplusplus
}
#endif
